package de.kleopatra.forms.description;

import java.util.ArrayList;
import java.util.List;

/** this is for persistance and handing around the descriptive data.
 *
 *  @version $ $Revision: 1.1.1.1 $ $Date: 2004/05/17 15:03:43 $
 *  @author (C) 2003 Jeanette Winzenburg, Berlin
 *
 */
public class DefaultLayoutDescription implements LayoutDescription {

	protected List rows;
	protected List columns;
	protected List constraints;
	protected Object layoutID;
	protected LayoutBorder border;
	public DefaultLayoutDescription() {
		rows = createList();
		columns = createList();
		constraints = createList();
	}

	public DefaultLayoutDescription(LayoutDescription description) {
		copyFrom(description);
	}

	public void copyFrom(LayoutDescription description) {
		setLayoutID(description.getLayoutID());
		setRows(createList(description.getRows()));
		setColumns(createList(description.getColumns()));
		setListConstraints(createList(description.getConstraints()));
		setBorder(description.getBorder());
	}

	public String toString() {
		return String.valueOf(getLayoutID()) + "\n" + super.toString() + "\n"
					 + getConstraints() + "\n" + getRows() + "\n" + getColumns();
	}

//---------------------------LayoutDescription
	public List getColumns() {
		return columns;
	}

	public List getRows() {
		return rows;
	}

	public List getConstraints() {
		return constraints;
	}

	public Object getLayoutID() {
		return layoutID;
	}

	public void setLayoutID(Object layoutID) {
		this.layoutID = layoutID;
	}

	public void setBorder(LayoutBorder border) {
		this.border = border;
	}

	public LayoutBorder getBorder() {
		return border;
	}

//---------------------------hacking for easy persistence. Tread as private. NEVER use directly from outside

	/** DO NOT USE - public as an implementation side-effect.
	 *
	 */
	public void setRows(List rows) {
		this.rows = rows;
	}

	/** DO NOT USE - public as an implementation side-effect.
	 *
	 */
	public void setColumns(List columns) {
		this.columns = columns;
	}

	/** DO NOT USE - public as an implementation side-effect.
	 *
	 */
	public void setListConstraints(List constraints) {
		this.constraints = constraints;
	}

	/** DO NOT USE - public as an implementation side-effect.
	 *
	 */
	public List getListConstraints() {
		return this.constraints;
	}

//---------------------------hacking for easy persistence. NEVER use directly
//---------------------------factory methods
	private List createList(List original) {
		List list = createList();
		list.addAll(original);
		return list;
	}

	private List createList() {
		return new ArrayList();
	}
}
