package de.kleopatra.forms.description;

import java.beans.PropertyChangeListener;
import java.util.List;

/** Factory to create descriptive elements for the LayoutBuilder.
 *
 * @version $Revision: 1.1.1.1 $ $Date: 2004/06/04 10:03:48 $
 *  @author (C) 2003 Jeanette Winzenburg, Berlin
 *
 */
public interface LayoutFactory {

//---------------------------information methods
	public List getConstraintHAlignmentTypes();

	public List getConstraintVAlignmentTypes();

	public List getRowContentTypes();

	public List getRowGapTypes();

	public Object getRowGlueType();

	public List getColumnContentTypes();

	public List getColumnGapTypes();

	public Object getColumnGlueType();

	public List getBorderTypes();

//---------------------------factory methods
	public Row createRow();

	public Row createRow(String encodedString);

	public Row createRow(Object contentType);

	public Row createRowGap();

	public Row createRowGap(Object gapType);

	public Row createRowGlue();

	public Column createColumn(String encodedString);

	public Column createColumn();

	public Column createColumn(Object contentType);

	public Column createColumnGap();

	public Column createColumnGap(Object gapType);

	public Column createColumnGlue();

	public Constraint createConstraint(String encodedString);

	public Constraint createConstraint();

	public LayoutBorder createBorder(String encodedString);

	public LayoutBorder createBorder(Object borderType);

	public LayoutBorder createBorder();

	public StyleMap getStyleMap();

  public void setStyleMap(StyleMap map);

  public void addPropertyChangeListener(PropertyChangeListener l);
  
  public void removePropertyChangeListener(PropertyChangeListener l);
}
