/*
 * Created on 09.05.2004
 *
 */
package de.kleopatra.forms.description.jgoodies;

import java.awt.Component;

import com.jgoodies.forms.layout.*;

/**
 * @author (C) Jeanette Winzenburg, Berlin
 * @version $Revision: 1.1.1.1 $ - $Date: 2004/05/18 13:10:21 $
 */
class AbstractLineStyle implements LineStyle {

	protected Object spec;
	protected Object typeKey;
	protected String description;
	public Object getSpec() {
		return spec;
	}

	public Object getLogicalType() {
		return typeKey;
	}

	public String getEncodedString() {
		return FormUtils.getEncodedString(spec);
	}

	public String toString() {
		return description + " " + FormUtils.getSpecDescription(spec);
	}

	public String getDescription() {
		return description;    // 
	}

	public String getMediumDescription() {
	  return description +  " " + FormUtils.getLongSpecDescription(spec);
	}
	
	public boolean isConstant() {
		return getSize() instanceof ConstantSize;
	}

	public int getPixelSize(Component comp) {
		if (isConstant()) {
			return ((ConstantSize) getSize()).getPixelSize(comp);
		}
		return -1;
	}

	public boolean isGlue() {

		//PENDING: need something better
		return (getPixelSize(null) == 0)
					 && (getResizeWeight() != RowSpec.NO_GROW);
	}

	public boolean isGap() {

		//PENDING: need something better
		return isConstant() && (getResizeWeight() == RowSpec.NO_GROW);
	}

//---------------------------- helpers to enable transparent handling of row/col  
	protected Size getSize() {

		// TODO Auto-generated method stub
		return isColumn() ? getColumnSpec().getSize() : getRowSpec().getSize();
	}

	protected double getResizeWeight() {
		return isColumn()
					 ? getColumnSpec().getResizeWeight()
					 : getRowSpec().getResizeWeight();
	}

	/** return columnSpec if isColumn(), null otherwise.
	 *
	 * @return
	 */
	protected ColumnSpec getColumnSpec() {
		if (isColumn()) {
			return (ColumnSpec) getSpec();
		}
		return null;
	}

	protected RowSpec getRowSpec() {
		if (!isColumn()) {
			return (RowSpec) getSpec();
		}
		return null;
	}

	protected boolean isColumn() {
		return getSpec() instanceof ColumnSpec;
	}
}
