/*
 * Created on 22.09.2003
 *
 */
package de.kleopatra.forms.description.jgoodies;

import com.jgoodies.forms.factories.Borders;
import com.jgoodies.forms.factories.Borders.EmptyBorder;

import de.kleopatra.forms.description.Style;

/** package private handler to manage type of border.
 *
 * @author (C) Jeanette Winzenburg, Berlin
 * @version $Revision: 1.2 $ - $Date: 2004/09/30 10:18:20 $
 */
class BorderStyle implements Style {

	EmptyBorder border;
	String description;
	Object typeKey;
	public BorderStyle(Object logicalType, EmptyBorder border,
			String description) {
		this.border = border;
		this.description = description;
		this.typeKey = logicalType;
	}

//-------------------------- implementing LogicalType
	public Object getLogicalType() {
		return typeKey;
	}

	public Borders.EmptyBorder getBorder() {
		return border;
	}

	public String getDescription() {
		return description;
	}

	public String getEncodedString() {
		return FormUtils.getEncodedString(border);
	}

//  public String getValidEncoding() {
//    return getEncodedString();
//  }
	public String toString() {
		return description + " "
					 + FormUtils.getBorderDescription(getEncodedString());
	}

	public boolean equals(Object other) {
		return (other instanceof BorderStyle)
					 && hasEqualBorder((BorderStyle) other);
	}

	private boolean hasEqualBorder(BorderStyle other) {
		if ((border == null) && (other.getBorder() == null)) {
			return true;
		}
		if ((border != null) && (other.getBorder() != null)) {
			return getEncodedString().equals(other.getEncodedString());
		}
		return false;
	}
}
