/*
 * Created on 22.09.2003
 *
 */
package de.kleopatra.forms.description.jgoodies;

import java.util.Arrays;
import java.util.List;

import com.jgoodies.forms.factories.Borders;

import de.kleopatra.forms.description.*;

/** Implementation of LayoutBorder for JGoodies Forms.
 * <p>
 * NOTE: this class is public and has public constructors
 * as an implementation side-effect, only. Don't instantiate/access
 * dirctly from code.
 *
 * @author (C) Jeanette Winzenburg, Berlin
 * @version $Revision: 1.1.1.1 $ - $Date: 2004/06/04 10:03:48 $
 */
public final class JGoodiesBorder extends AbstractStylable
		implements LayoutBorder {

	private static final BorderStyle DEFAULT_BORDER_TYPE = new BorderStyle(NO_BORDER,
																													null,
																													"no border");

//------------------------ constructors 
	public JGoodiesBorder() {
	  this(DEFAULT_BORDER_TYPE);
	}

//  public JGoodiesBorder(String borderString) {
//    setEncodedString(borderString);
//  }
	public JGoodiesBorder(BorderStyle logicalType) {
		setStyle(logicalType);
	}

//---------------------------- implementing Style
//----------------------- implementing Stylable
	public List getStyles() {
		return LayoutBuilderFactory.getLayoutFactory().getBorderTypes();
	}

//----------------------------- implementing Border 
	public boolean isEnabled() {
		return !NO_BORDER.equals(getLogicalType());
	}

//----------------------------------- convenience 
	public Borders.EmptyBorder getEmptyBorder() {
		return ((BorderStyle) getStyle()).getBorder();
	}

//--------------------------- implementing super's abstract 
	protected boolean isPredefinedStyle(Object typeKey) {
		return Arrays.asList(PREDEFINED_TYPES).contains(typeKey);
	}

	protected Style createCustomStyle(String encodedString) {
		return new BorderStyle(CUSTOM, (Borders
        	.EmptyBorder) Borders
        		.createEmptyBorder(encodedString), "custom");
	}

	protected Style createStyle(Style current, Object newTypeKey) {
		BorderStyle border = (BorderStyle) current;
		return new BorderStyle(newTypeKey,
				(Borders.EmptyBorder) border.getBorder(), String.valueOf(newTypeKey));
	}

	protected Style getDefaultStyle() {
		return DEFAULT_BORDER_TYPE;
	}

	protected boolean checkStyle(Object style) {
		return style instanceof BorderStyle;
	}

	protected Object createComparable(String encoded) {
		return (Borders.EmptyBorder) Borders.createEmptyBorder(encoded);
	}
}

