package de.kleopatra.forms.description.jgoodies;

import java.util.Arrays;
import java.util.List;

import com.jgoodies.forms.layout.RowSpec;

import de.kleopatra.forms.description.*;

/** Implementation of Row for JGoodies Forms.
 *
 * <p>
 * NOTE: this class is public and has public constructors
 * as an implementation side-effect, only. Don't instantiate/access
 * directly from code.
 *  @version $Revision: 1.2 $ $Date: 2004/09/30 10:18:21 $
 *  @author (C) 2003 Jeanette Winzenburg, Berlin
 *
 */
public final class JGoodiesRow extends JGoodiesLine implements Row {

	private static RowStyle DEFAULT_SPEC_DESCRIPTION =
		new RowStyle(DEFAULT_CONTENT, new RowSpec("c:d:n"), "default");
	public JGoodiesRow() {
		this(DEFAULT_SPEC_DESCRIPTION);
	}

//  public JGoodiesRow(RowSpec spec) {
//    this.spec = spec;
//  }
	public JGoodiesRow(RowStyle rowType) {
		setStyle(rowType);
	}

	//-------------------------- type specific implementations of Line
//  public void setType(Object desc) {
//    if (desc instanceof RowType) {
//      setStyle((RowType) desc);
//    } else {
//      String encoded = FormUtils.stripEncoding(String.valueOf(desc));
//      RowSpec comparing = new RowSpec(encoded);
//      String comparableEncoding = FormUtils.getEncodedString(comparing);
//      setEncodedString(comparableEncoding);
//    }
//  }
//--------------------------------- convenience
	public RowSpec getRowSpec() {
		return getRowType().getRowSpec();
	}

	//----------------------implementing abstract JGoodiesLine methods
	protected List getContentTypes() {
		return LayoutBuilderFactory.getLayoutFactory().getRowContentTypes();
	}

	protected List getGapTypes() {
		return LayoutBuilderFactory.getLayoutFactory().getRowGapTypes();
	}

	protected Object getGlueType() {
		return LayoutBuilderFactory.getLayoutFactory().getRowGlueType();
	}

//---------------------------implement AbstractPersistableStyle
	protected boolean isPredefinedStyle(Object typeKey) {
		return Arrays.asList(PREDEFINED_TYPES).contains(typeKey);
	}

	protected Style createStyle(Style current, Object newTypeKey) {
		RowStyle rowType = (RowStyle) current;
		return new RowStyle(newTypeKey, rowType.getRowSpec(),
				String.valueOf(newTypeKey));
	}

	protected Style createCustomStyle(String encodedString) {
		return new RowStyle(CUSTOM, new RowSpec(encodedString), "custom");
	}

	protected Style getDefaultStyle() {
		return DEFAULT_SPEC_DESCRIPTION;
	}

	protected boolean checkStyle(Object style) {
		return style instanceof RowStyle;
	}

	protected Object createComparable(String encoding) {
		return new RowSpec(encoding);
	}

	private RowStyle getRowType() {
		return (RowStyle) getStyle();
	}
}
