package de.kleopatra.forms.view.builder;

import java.beans.PropertyChangeListener;

import de.kleopatra.forms.description.LayoutDescription;
import de.kleopatra.view.presentation.Presentation;

/**
 *   Handles synch and state of a pair of Presentation/LayoutDescription.
 *
 * @version $Revision: 1.1.1.1 $ - $Date: 2004/06/25 09:01:00 $
 *  @author (C) 2003 Jeanette Winzenburg, Berlin
 */
public interface FormDescription {

  public Presentation getPresentation();

  public void setPresentation(Presentation presentation);

  public LayoutDescription getLayoutDescription();

  public void setLayoutDescription(LayoutDescription description);

  /* bound property.
   */
  public Object getFormID();

  /**
   *  pre: formID != null
   *  Post: getFormID == formID AND
   *  getLayoutDescription().getLayoutID == formID AND
   *  getPresentation.getPresentationID == formID.
   */
  public void setFormID(Object formID);

  /* bound property.
   */
  public boolean isClean();

  /** for use in FormManager only...
   */
  public void setClean(boolean clean);

  public void addPropertyChangeListener(String property,
      PropertyChangeListener l);

  public void removePropertyChangeListener(String property,
      PropertyChangeListener l);
}
