package de.kleopatra.view;

import java.awt.BorderLayout;
import java.awt.Color;

import javax.swing.*;
import javax.swing.border.Border;

/**	Convenience borded panel with text to represent an unknown comp type in layoutEditor.
 *
 *	@version $Revision: 1.1.1.1 $ $Date: 2003/10/14 11:13:47 $
 *	@author (C) 2003 Jeanette Winzenburg, Berlin
 *
 */
public class JTitledPlaceHolder extends JPanel {
	private final static String defaultTitle ="PlaceHolder";
	protected JLabel titleLabel;
	protected Border border;

	public JTitledPlaceHolder() {
		this(defaultTitle);
	}

	public JTitledPlaceHolder(String title) {
		initComponents();
		setText(title);
	}

	public void setText(String title) {
		if (!hasLabel() && (title == null)) return;
		getLabel().setText(title);
	}

	public String getText() {
		if (hasLabel()) {
			return getLabel().getText();
		}
		return null;
	}

//---------------------------init

	protected void initComponents() {
		setLayout(new BorderLayout());
		titleLabel = createLabel("titleLabel");
		titleLabel.setAlignmentX(CENTER_ALIGNMENT);
		titleLabel.setAlignmentY(CENTER_ALIGNMENT);
		add(titleLabel);
		setName("titledSeparator");
		setBorder(createBorder());
	}

//---------------------------factory methods

	protected boolean hasLabel() {
		return titleLabel != null;
	}

	protected JLabel getLabel() {
		if (titleLabel == null) {
			titleLabel = createLabel(null);
		}
		return titleLabel;
	}

//---------------------------factory methods

	protected JLabel createLabel(String id) {
		JLabel label = new JLabel();
		label.setName(id);
		return label;
	}

	protected Border createBorder() {
		return BorderFactory.createLineBorder(Color.black);
	}
}
