/*
 * Created on 30.09.2004
 *
 */
package de.kleopatra.view.binding;

import javax.swing.JComponent;

/**
 * @author (C) 2004 Jeanette Winzenburg, Berlin
 * @version $Revision: 1.2 $ - $Date: 2004/10/01 12:27:06 $
 */
public class BindingComponentNotFoundException extends BindingException {

  public BindingComponentNotFoundException(String message) {
    super(message);
  }

  public BindingComponentNotFoundException(String message, Throwable cause) {
    super(message, cause);
  }

  public BindingComponentNotFoundException(JComponent parent,
      BindingMetaData metaData) {
    this(createMessage(parent, metaData));
  }

  private static String createMessage(JComponent parent,
      BindingMetaData metaData) {
    String message = "could not find Component to bind in "
                       + "\nparent name: " + parent.getName()
                       + "\nparent class: " + parent.getClass()
                       + "\ncomponentName: " + metaData.getComponentName()
                       + "\nmetaData class: " + metaData.getClass()
                       + "\ncomponent class: " + metaData.getComponentClass()
                       + "\ntarget class: " + metaData.getTargetClass();
    return message;
  }
}
