/*
 * Created on 23.09.2004
 *
 */
package de.kleopatra.view.binding;

import javax.swing.JComponent;

import com.jgoodies.binding.value.ValueModel;

/**
 * Handler to find and bind a Component to a ValueModel.
 * 
 * @author (C) 2004 Jeanette Winzenburg, Berlin
 * @version $Revision: 1.3 $ - $Date: 2004/10/01 12:27:06 $
 */
public interface BindingHandler {

  /**
   * Find a fitting component in container and bind it to model. <p>
   *
   * The component is searched by name, checked if appropriate for
   * the type of binding as required by metaData and configured with
   * metaData, if appropriate. <p>
   *
   *
   * @param container the parent to search
   * @param metaData binding infos
   * @param valueModel the model to keep in synch with the found component's
   *    data.
   *
   * @throws BindingComponentNotFoundException if no appropriate component is
   *   found.
   * @throws NullPointerException if any of the parameters is null.
   *
   */
  void bind(JComponent container, BindingMetaData metaData,
            ValueModel valueModel);
}
