/*
 * Created on 30.09.2004
 *
 */
package de.kleopatra.view.binding;

/**
 * @author (C) 2004 Jeanette Winzenburg, Berlin
 * @version $Revision: 1.2 $ - $Date: 2004/10/01 12:27:06 $
 */
public class BindingHandlerNotFoundException extends BindingException {

  public BindingHandlerNotFoundException(String message) {
    super(message);
  }

  public BindingHandlerNotFoundException(String message, Throwable cause) {
    super(message, cause);
  }

  public BindingHandlerNotFoundException(BindingMetaData metaData) {
    this(createMessage(metaData));
  }

  private static String createMessage(BindingMetaData metaData) {
    String message = "could not find BindingHandler for BindingMetaData "
                       + "\ncomponentName: " + metaData.getComponentName()
                       + "\nmetaData class: " + metaData.getClass()
                       + "\ncomponent class: " + metaData.getComponentClass()
                       + "\ntarget class: " + metaData.getTargetClass();
    return message;
  }
}
