/*
 * Created on 23.09.2004
 *
 */
package de.kleopatra.view.binding;

/**
 * Responsible for finding an appropriate BindingHandler for
 * a given BindingMetaData.
 *
 * @author (C) 2004 Jeanette Winzenburg, Berlin
 * @version $Revision: 1.5 $ - $Date: 2004/10/01 12:27:06 $
 */
public interface BindingMap {

  /** returns an appropriate BindingHandler for bindingMetaData.<p>
   *
   *
   * @param metaData
   * @return a BindingHandler which guarantees to handle the binding.
   * @throws BindingHandlerNotFoundException if none is found.
   */
  BindingHandler getBindingHandler(BindingMetaData metaData);

  void addBindingHandler(Class handledClass, Class handlerClass);

  void addBindingHandler(String handledClassName, String handlerClassName);
}
