/*
 * Created on 24.09.2004
 *
 */
package de.kleopatra.view.binding;

import javax.swing.JList;

import com.jgoodies.binding.value.ValueModel;

/**
 * BindingMetaData for use by list binding.<p>
 *
 * NOTE: the property must refer to list-like value.
 *
 *
 * @author (C) 2004 Jeanette Winzenburg, Berlin
 * @version $Revision: 1.5 $ - $Date: 2004/10/04 11:56:04 $
 */
public class ListBindingMetaData extends BindingMetaData {

  private ValueModel selectionModel;

//---------------------- convenience constructors
  public ListBindingMetaData(String componentName) {
    super(componentName, JList.class);
  }

  public ListBindingMetaData(String componentName, String propertyName) {
    super(componentName, propertyName, JList.class);
  }

  /** a slot to support optional binding to the selection state of the
   * the list.
   *
   * @param model
   */
  public void setSelectionValueModel(ValueModel model) {
    this.selectionModel = model;
  }

  public ValueModel getSelectionValueModel() {
    return selectionModel;
  }
}
