/*
 * Created on 04.05.2004
 *
 */
package de.kleopatra.view.binding;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.logging.Logger;

import javax.swing.SpinnerModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import com.jgoodies.binding.value.ValueModel;

/**
 * @author (C) Jeanette Winzenburg, Berlin
 * @version $Revision: 1.3 $ - $Date: 2004/10/04 11:56:04 $
 */
public class SpinnerConnector {

  private ValueModel subject;
  private SpinnerModel delegate;
  private PropertyChangeListener subjectListener;
  private ChangeListener spinnerListener;
  public SpinnerConnector(SpinnerModel delegate, ValueModel subject) {
    if (subject == null) {
      throw new NullPointerException("The subject must not be null.");
    }
    if (delegate == null) {
      throw new NullPointerException("The spinnerModel must not be null.");
    }
    this.subject = subject;
    this.delegate = delegate;
    updateSpinnerModel(subject.getValue());
    delegate.addChangeListener(getSpinnerListener());
    subject.addValueChangeListener(getSubjectListener());
  }

//------------------------

  /** updates spinner from subject. */
  private void updateSpinnerModel(Object value) {
    try {
      delegate.setValue(value);
    } catch (IllegalArgumentException ex) {
      Logger.getAnonymousLogger().warning("updateSpinnerModel: " + ex
          + "\n when trying to set " + value);
    }
  }

  protected void updateSubject() {
    subject.setValue(delegate.getValue());
  }

  //-------------------- init
  private PropertyChangeListener createValueChangeListener() {
    PropertyChangeListener l = new PropertyChangeListener() {

      public void propertyChange(PropertyChangeEvent evt) {
        updateSpinnerModel(evt.getNewValue());
      }
    };
    return l;
  }

  private ChangeListener createChangeListener() {
    ChangeListener l = new ChangeListener() {

      public void stateChanged(ChangeEvent e) {
        updateSubject();
      }
    };
    return l;
  }

  private PropertyChangeListener getSubjectListener() {
    if (subjectListener == null) {
      subjectListener = createValueChangeListener();
    }
    return subjectListener;
  }

  private ChangeListener getSpinnerListener() {
    if (spinnerListener == null) {
      spinnerListener = createChangeListener();
    }
    return spinnerListener;
  }
}
