/*
 * Created on 24.09.2004
 *
 */
package de.kleopatra.view.binding;

import javax.swing.text.JTextComponent;

/**
 * BindingMetaData for use by text binding.
 *
 * @author (C) 2004 Jeanette Winzenburg, Berlin
 * @version $Revision: 1.3 $ - $Date: 2004/10/01 12:27:07 $
 */
public class TextBindingMetaData extends BindingMetaData {

  private boolean editable;
  private boolean editableSet;

//-------------------- convenience constructors
  public TextBindingMetaData(String componentName) {
    this(componentName, JTextComponent.class);
  }

  public TextBindingMetaData(String componentName, String propertyName) {
    this(componentName, propertyName, JTextComponent.class);
  }

  public TextBindingMetaData(String componentName, Class componentClass) {
    super(componentName, componentClass);
  }

  public TextBindingMetaData(String componentName, String propertyName,
      Class componentClass) {
    super(componentName, propertyName, componentClass);
  }

//---------------------- overriding super
//---------------------- additional accessing 
  public boolean isEditable() {
    return editableSet ? editable : getDefaultEditability();
  }

  public void setEditable(boolean editable) {
    editableSet = true;
    this.editable = editable;
  }

//-------------------------------- 

  /**
   * overrides super to enable commitOnFocusLost by default.
   */
  protected void initDefaultCommit() {
    setCommitOnFocusLost(true);
  }

  private boolean getDefaultEditability() {
    return true;
  }
}
