package de.kleopatra.view.factory;

import java.util.Set;

/**	Mapping between generic componentTypes and widget specific widget classes.
 * 
 * <p>
 * NOTE: this api will be changed to include the additional
 * methods from ExComponentTypeMap. 
 * 
 *
 * @author (C) Jeanette Winzenburg, Berlin
 * @version $Revision: 1.1.1.1 $ - $Date: 2004/05/05 10:02:18 $
 *
 */
public interface ComponentTypeMap {

	public void addComponentType(Object componentType, String className);

	public void addContainerType(Object containerType, String className);

	public void addScrollableType(Object scrollableType);
	
	public boolean shouldScroll(Object componentType);

	public void addComponentType(Object componentType, Class clazz);
	
	public void addContainerType(Object componentType, Class clazz);
	
	public Object getComponentInstance(Object componentType);
	
	/** returns the class of the most fitting input widget given the generic type.
	 * might be null.
	 * @deprecated: use ExComponentTypeMap's getInstance() instead.
	 */
//	public Class getClass(Object componentType);


	/** returns a Collection of all generic component types.
	 */
	public Set getComponentTypes();

	/** returns a Collection of all generic container types.
	 */
	public Set getContainerTypes();

	/** returns the generic type of the widget.
	 * might be null.
	 * <p>
	 * used in FormReader only (which is not used currently).
	 * May be removed in future versions ... 
	 */
	public Object getComponentType(Class clazz);

}
