package de.kleopatra.view.factory;

import java.awt.Component;
import java.awt.Container;

import de.kleopatra.view.presentation.PresentationManager;

//import de.kleopatra.view.DataBinding;

/**	Factory to create components as appropriate for a concrete widget toolkit.
 *
 *
 *
 * @author (C) Jeanette Winzenburg, Berlin
 * @version $Revision: 1.1.1.1 $ - $Date: 2003/10/14 11:13:47 $
 *
 */
public interface UIFactory {

//---------------------------basic methods
	/** returns the most appropriate Component based on componentID and componentType.
	 *  it's up to the factory to decide which is appropriate.
	 *	POST: result != null.
	 */
	public Component createComponent(Object componentID, Object componentType);

	/** sets map used to map between
	 *	generic componentType <--> component class in the context of this toolkit.
	 *	PRE: componentTypes != null
	 */
	public void setComponentTypeMap(ComponentTypeMap componentTypes);

	/** returns the currently used ComponentTypeMap.
	 *	Clients can use it to add type <--> class mappings at any time.
	 */
	public ComponentTypeMap getComponentTypeMap();

//---------------------------experimental

	public PresentationManager getPresentationManager();

	/** tries to extract the componentID from a given comp.
	 *	result may be null.
	 *	PRE: comp != null
	 */
	public Object getComponentID(Component comp);

	/** POST: result != null.
	 */
	public Container createDefaultContainer(Object componentID);

}
