package de.kleopatra.view.factory;

import java.awt.KeyboardFocusManager;
import java.awt.event.ActionEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.*;


/**	helper to have a place for tweaking. a bit hacky...
 *
 * @author (C) Jeanette Winzenburg, Berlin
 * @version $Revision: 1.1.1.1 $ - $Date: 2003/10/14 11:13:47 $
 *
 */
public class UITweaks {
	private static final String NOTIFY_TWEAK_KEY = "notify-accept-focus-lost";
	private static final String NOTIFY_KEY = "notify-field-accept";

	public UITweaks() {
	}

	/** installs all known tweaks.
	 */
	public void initTweaks() {
		tweakTextFields();
	}

	/** tweaks textFields actionMap for notifyAction.
	 *	<p>
	 *	[No longer: replaces the original with an action that transfers focus to next comp.]
	 *	installs a focusListener with the keyboardfocusManager
	 *		that fires the original if the old permanentFocusOwner has been a textfield.
	 *	<p>
	 * 	PENDING: does not address the problem with the defaultButton
	 *		- enter is still eaten
	 *	<p>
	 *	PENDING: do we really want to fire in all cases? JComboBox does so if the editor
	 *		value had changed
	 */
	public void tweakTextFields() {
		JTextField field = new JTextField();
		Action notifyAction = field.getActionMap().get(NOTIFY_KEY);
		if (notifyAction != null) {
			ActionMap map = getTopLevelMap(field.getActionMap(), NOTIFY_KEY);
			map.put(NOTIFY_TWEAK_KEY, notifyAction);
			map.put(NOTIFY_KEY, createNotifyAction(notifyAction));
			installTextFocusListener();
		}

	}

//---------------------------helper

	protected void installTextFocusListener() {
		KeyboardFocusManager manager = KeyboardFocusManager.getCurrentKeyboardFocusManager();
		PropertyChangeListener l = new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
				if (e.getOldValue() instanceof JTextField) {
					fireNotify((JTextField) e.getOldValue());
				}
			}
		};
		manager.addPropertyChangeListener("permanentFocusOwner", l);
	}

	protected void fireNotify(JTextField field) {
		Action notifyAction = field.getActionMap().get(NOTIFY_TWEAK_KEY);
		if ((notifyAction != null) && notifyAction.isEnabled()) {
			notifyAction.actionPerformed(null);
		}
	}

/*	protected Action getNotifyAction(JTextField field) {
		return ;
	}
*/
	protected ActionMap getTopLevelMap(ActionMap map, Object key) {
		while ((map.getParent() != null) && (map.get(key) != null)) {
			map = map.getParent();
		}
		return map;
	}

	protected Action createNotifyAction(final Action delegate) {
		Action action = new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				delegate.actionPerformed(e);
		//		KeyboardFocusManager.getCurrentKeyboardFocusManager().focusNextComponent();
			}
		};
		return action;
	}

	protected void bindAction(ActionMap map, Action action) {

	}

}
