/*
 * Created on 05.09.2003
 *
 */
package de.kleopatra.view.presentation;

import java.awt.Component;
import java.util.HashMap;
import java.util.Map;
import java.util.logging.Logger;

import de.kleopatra.persistence.ResourceManager;
import de.kleopatra.support.HandlerMap;

/**
 * @author (C) Jeanette Winzenburg, Berlin
 * @version $Revision: 1.1.1.1 $ - $Date: 2004/05/05 10:02:18 $
 */
public class DefaultCustomizerMap extends HandlerMap
		implements CustomizerMap {

	protected static final Logger LOGGER = Logger.getLogger("DefaultCustomizerMap");
	
//  protected Map customizers;
	protected ComponentCustomizer formCustomizer;
	public DefaultCustomizerMap() {
		initCustomizers();
	}

//----------------------- CustomizerMap
	public ComponentCustomizer getCustomizer(Class valueClass) {
		return (ComponentCustomizer) getHandler(valueClass);  
	}

	public void addCustomizer(String componentClass, String handlerClass) {
		addHandler(componentClass, handlerClass);
	}

	public void addCustomizer(Class componentClass, Class handlerClass) {
		addHandler(componentClass, handlerClass);
	}

	public ComponentCustomizer getFormCustomizer() {
		if (formCustomizer == null) {
			formCustomizer = createEmptyCustomizer();
		}
		return formCustomizer;
	}

	public void setFormCustomizer(String handlerClass) {
		try {
			setFormCustomizer(ResourceManager.getInstance().getClass(handlerClass));
		} catch (Exception ex) {
			LOGGER.info("could not find/access/instantiate custom form customizer " + handlerClass);
		}
	}

	public void setFormCustomizer(Class handlerClass) {
		try {
			formCustomizer = (ComponentCustomizer) handlerClass.newInstance();
		} catch (Exception ex) {
			LOGGER.info("could not find/access/instantiate custom form customizer " + handlerClass);
		} 
	}
//----------------------helper
	protected boolean checkType(Object handler) {
		return handler instanceof ComponentCustomizer;
	}

	protected void initCustomizers() {
		handlers = createMap();
		handlers.put(Object.class, createEmptyCustomizer());
	}

//------------------------factory
	protected ComponentCustomizer createEmptyCustomizer() {
		ComponentCustomizer empty = new ComponentCustomizer() {

			public void customize(Component comp, PresentationDescription desc,
					Class clazz) {}

			public void customize(Component comp, PresentationDescription desc) {}

			public PresentationDescription createDescription(Component comp) {
				return new DefaultPresentationDescription("Stand-in - does nothing");
			}
		};
		return empty;
	}

	protected Map createMap() {
		return new HashMap();
	}

}
