package de.kleopatra.view.presentation;

import java.util.ArrayList;
import java.util.List;

/** Default implementation of Presentation.
 *
 * @author (C) Jeanette Winzenburg, Berlin
 * @version $Revision: 1.2 $ - $Date: 2004/09/30 10:18:21 $
 */
public class DefaultPresentation implements Presentation {

	protected List descriptions;
	protected Object presentationID;
  private String bundleName;
	
	/** parameterless constructor of persistence. */
	public DefaultPresentation() {
	}

	public DefaultPresentation(Object id) {
		setPresentationID(id);
	}

//---------------------------Presentation
	public Object getPresentationID() {
		return presentationID;
	}

	/** sets the presentationID. <p>
	 */
	public void setPresentationID(Object presentationID) {
		this.presentationID = presentationID;
	}

	public List getPresentationDescriptions() {
		return getDescriptions();
	}

	public void setResourceBundleName(String bundleName) {
	  this.bundleName = bundleName;
	}
	
	public String getResourceBundleName() {
	  return bundleName;
	}

//  public void updateDescriptions(ResourceBundle bundle) {
//    if ((presentationID == null) || (bundle == null))return;
//    BundleHandler handler = new DefaultBundleHandler();
//    handler.updatePresentation(bundle, this);
//  }

//---------------------------accessing

  /** pre: presentationDescription != null.
	 */
	public void addPresentationDescription(
			PresentationDescription presentationDescription) {
		getDescriptions().add(presentationDescription);
	}

//---------------------------persistance hack - do not use

	/** sets the List of presentationDescriptions. <p>
	 *  do not use - public access is a 
	 *  side-effect of default persistence.
	 *
	 * pre: presentationDescriptions != null.
	 */
	public void setPresentationDescriptions(List presentationDescriptions) {
		this.descriptions = presentationDescriptions;
	}
	;

//---------------------------factory methods
	protected List getDescriptions() {
		if (descriptions == null) {
			descriptions = createList();
		}
		return descriptions;
	}

	protected List createList() {
		return new ArrayList();
	}

}
