package de.kleopatra.view.presentation;

import java.awt.Component;
import java.awt.Container;

/** Manager to customize all children of a container.
 *
 * @author (C) Jeanette Winzenburg, Berlin
 * @version $Revision: 1.1.1.1 $ - $Date: 2003/11/24 15:23:59 $
 *
 */
public interface PresentationManager {

	public static final String LABEL_POSTFIX = "Label";

	/** removed: manager is responsible, don't try to interfere
	public ComponentCustomizer getCustomizer(Component comp);
*/
	public void customize(Container container, Presentation presentation);

	public void customize(Container container, Presentation presentation, Class targetClass);
	
	public PresentationDescription createPresentationDescription(Component comp);

	public CustomizerMap getCustomizerMap();

	public void setCustomizerMap(CustomizerMap map);

	/** experimental: used to customize a PResentationManager for design mode.
	 * 
	 * @param actionFactory
	 */
	public void setActionFactory(ActionFactory actionFactory);
}
