package de.kleopatra.view.table;


import java.awt.Component;

import javax.swing.JComponent;
import javax.swing.JTable;
import javax.swing.table.TableCellRenderer;


/**	enable tooltips for renderers.
 *	PENDING: handle selection as well
 *
 *
 * @author (C) Jeanette Winzenburg, Berlin
 * @version $Revision: 1.1.1.1 $ - $Date: 2004/05/11 09:53:56 $
 *
 */
public class ToolTipRenderer implements TableCellRenderer {
	protected TableCellRenderer delegate;

	public ToolTipRenderer(TableCellRenderer delegate) {
		this.delegate = delegate;
	}


	protected String getToolTip(JTable table, Object value, int column) {
	  return value != null ? value.toString() : null;
	}
	
	public Component getTableCellRendererComponent(JTable table, Object value,
		boolean isSelected, boolean hasFocus, int row, int col) {
		Component comp = delegate.getTableCellRendererComponent(table, value,
			isSelected, hasFocus, row, col);
		if (comp instanceof JComponent) {
		  ((JComponent) comp).setToolTipText(getToolTip(table, value, col));
		}
		return comp;
	}
}
